<?php
/**
* 
*
*
* Common function to render the display
*/
function tap_the_web_catalog_manufacturer_display($manufacturer,$type,$class,$page){

    //start output
    $html = '';

    //do header - nav
    $html .= '<div class="manufacturers-header-container">';

        $html .= '<div class="product-filter-wrapper">';

            $html .= '<label>'.__('Brand','tap-the-web-catalog').'</label>';
            $html .= '<select class="product-filter manufacturers-filter">';

                //do blank option
                if('' == $manufacturer){
                    $html .= '<option selected="selected" value=""></option>';
                } else {
                    $html .= '<option value=""></option>';
                }

                //get terms
                $terms = get_terms( 'manufacturers', array(
                    'hide_empty' => true,
                ));

                foreach($terms as $term){

                    $slug = $term->slug;
                    $name = $term->name;

                    if($slug == $manufacturer){
                        $html .= '<option selected="selected" value="'.$slug.'">'.$name.'</option>';
                    } else {
                        $html .= '<option value="'.$slug.'">'.$name.'</option>';
                    }
        
                }
                
            $html .= '</select>';
        $html .= '</div>';
        $html .= '<div class="product-filter-wrapper">';
            $html .= '<label>'.__('Product Types','tap-the-web-catalog').'</label>';
            $html .= '<select class="product-filter types-filter">';
                
                //do blank option
                if('' == $type){
                    $html .= '<option selected="selected" value=""></option>';
                } else {
                    $html .= '<option value=""></option>';
                }    

                //get terms
                $terms = get_terms( 'types', array(
                    'hide_empty' => true,
                ));

                foreach($terms as $term){

                    $slug = $term->slug;
                    $name = $term->name;

                    if($slug == $type){
                        $html .= '<option selected="selected" value="'.$slug.'">'.$name.'</option>';
                    } else {
                        $html .= '<option value="'.$slug.'">'.$name.'</option>';
                    }
        
                }
                
            $html .= '</select>';
        $html .= '</div>';
        $html .= '<div class="product-filter-wrapper">';

            $html .= '<label>'.__('Product Classes','tap-the-web-catalog').'</label>';
            $html .= '<select class="product-filter classes-filter">';

                //do blank option
                if('' == $class){
                    $html .= '<option selected="selected" value=""></option>';
                } else {
                    $html .= '<option value=""></option>';
                }

                //get terms
                $terms = get_terms( 'classes', array(
                    'hide_empty' => true,
                ));

                foreach($terms as $term){

                    $slug = $term->slug;
                    $name = $term->name;

                    if($slug == $class){
                        $html .= '<option selected="selected" value="'.$slug.'">'.$name.'</option>';
                    } else {
                        $html .= '<option value="'.$slug.'">'.$name.'</option>';
                    }
        
                }
                
            $html .= '</select>';
        $html .= '</div>';

    $html .= '</div>';







    //do body - listing
    $html .= '<ul class="manufacturers-list-container">';
        
        $posts_per_page = 12;

        //do query
        $args = array(
            'posts_per_page'    => $posts_per_page,
            'paged'            => $page,
            'post_type'         => 'ttw_products',
            'order'             => 'ASC',
            'orderby'           => 'menu_order',
        );

        $tax_query = array();

        //do manufacturer first
        if($manufacturer != ''){
            array_push($tax_query,array(
                'taxonomy' => 'manufacturers',
                'field'    => 'slug',
                'terms'    => $manufacturer
            ));
        }

        if($type != ''){
            array_push($tax_query,array(
                'taxonomy' => 'types',
                'field'    => 'slug',
                'terms'    => $type
            ));
        }

        if($class != ''){
            array_push($tax_query,array(
                'taxonomy' => 'classes',
                'field'    => 'slug',
                'terms'    => $class
            ));
        }


        //add the tax query to the arguments
        $args['tax_query'] = $tax_query; //hopefully this will work even if it's blank

        $posts = get_posts( $args );

        if($posts){

            //loop through the posts
            foreach($posts as $post){
                $post_id = $post->ID;
                $post_name = $post->post_title;
                $post_slug = $post->post_name;
                $post_image = get_post_meta($post_id, 'product_image', true);
                $post_link = get_permalink($post_id);

                $html .= '<li class="manufacturers-list-item manufacturers-list-item-'.$post_slug.'">';
                    //wrap everything in a link
                    $html .= '<a href="'.$post_link.'">';	
                        //do image section
                        if(strlen($post_image) > 0){
                            $html .= '<div class="image-container">';
                                $html .= '<img src="'.$post_image.'" alt="'.$post_name.'" >';
                            $html .= '</div>';	
                        }

                        //do title section
                        $html .= '<div class="title-container">';
                                $html .= '<h4>'.$post_name.'</h4>';
                        $html .= '</div>';	

                    $html .= '</a>';

                $html .= '</li>';


            }

        } else {
            //there were no results
            $html .= '<li>'.__('Sorry, there are no products that meet this criteria.','tap-the-web-catalog').'</li>';
        }

            
    $html .= '</ul>';



    //do footer - pagination
    $html .= '<ul class="manufacturers-footer-container">';
        
        //do query for full amount
        //do query
        $args = array(
            'numberposts'    => -1,
            'post_type'      => 'ttw_products',
        );

        $tax_query = array();

        //do manufacturer first
        if($manufacturer != ''){
            array_push($tax_query,array(
                'taxonomy' => 'manufacturers',
                'field'    => 'slug',
                'terms'    => $manufacturer
            ));
        }

        if($type != ''){
            array_push($tax_query,array(
                'taxonomy' => 'types',
                'field'    => 'slug',
                'terms'    => $type
            ));
        }

        if($class != ''){
            array_push($tax_query,array(
                'taxonomy' => 'classes',
                'field'    => 'slug',
                'terms'    => $class
            ));
        }

        //add the tax query to the arguments
        $args['tax_query'] = $tax_query; //hopefully this will work even if it's blank

        $posts = get_posts( $args );


        if($posts && count($posts) > $posts_per_page){ //we dont need to show the pagination if number less then posts per page

            $pages = ceil(count($posts)/$posts_per_page);

            if($pages>15){
                //do special display
                $special_pages = array(
                    1 => __('First','tap-the-web-catalog'),
                    $page-5 => $page-5,
                    $page-4 => $page-4,
                    $page-3 => $page-3,
                    $page-2 => $page-2,
                    $page-1 => $page-1,
                    $page => $page,
                    $page+1 => $page+1,
                    $page+2 => $page+2,
                    $page+3 => $page+3,
                    $page+4 => $page+4,
                    $page+5 => $page+5,
                    
                    $pages => __('Last','tap-the-web-catalog')
                );

                foreach($special_pages as $special_page_key => $special_page_value){

                    if($special_page_key > 0 && $special_page_key <= $pages){
                        if($special_page_key == $page){
                            $html .= '<li data="'.$special_page_key.'" class="active">'.$special_page_value.'</li>'; 
                        } else {
                            $html .= '<li data="'.$special_page_key.'" class="">'.$special_page_value.'</li>'; 
                        }
                    }

                    
                }

            } else {
                //do pagination
                for ($i = 1 ; $i <= $pages; $i++){ 

                    if($i == $page){
                        $html .= '<li data="'.$i.'" class="active">'.$i.'</li>'; 
                    } else {
                        $html .= '<li data="'.$i.'" class="">'.$i.'</li>'; 
                    }

                }
            }


                
        }


    $html .= '</ul>';

    return $html;
}
/**
* 
*
*
* Get html dat fo ajax request
*/
function tap_the_web_catalog_update_manufacturers_display(){

    $manufacturer = $_POST['manufacturer'];
    $type = $_POST['type'];
    $class = $_POST['class'];
    $page = intval($_POST['page']);

    echo tap_the_web_catalog_manufacturer_display($manufacturer,$type,$class,$page);

    wp_die(); 
}
add_action( 'wp_ajax_update_display', 'tap_the_web_catalog_update_manufacturers_display' );
add_action( 'wp_ajax_nopriv_update_display', 'tap_the_web_catalog_update_manufacturers_display' );

?>