<?php
/**
 * The template for displaying archive pages
 *
 * Used to display archive-type pages if nothing more specific matches a query.
 * For example, puts together date-based pages if no date.php file exists.
 *
 * If you'd like to further customize these archive views, you may create a
 * new template file for each one. For example, tag.php (Tag archives),
 * category.php (Category archives), author.php (Author archives), etc.
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/
 *
 * @package WordPress
 * @subpackage Twenty_Sixteen
 * @since Twenty Sixteen 1.0
 */

get_header(); 
wp_enqueue_script(array('tap_the_web_catalog_frontend_script'));
wp_enqueue_style(array('tap_the_web_catalog_frontend_style'));
?>

	<div id="primary" class="container">
		
		<?php
			//do custom content here
			//start output
			$html = '';

			$html .= '<ul class="manufacturers-list-container">';

				$taxonomy_name = 'manufacturers';

				//get all manufacturers
				$terms = get_terms( $taxonomy_name, array(
					'hide_empty' => true, //we dont want to show items with no items just yet
				));
			
	
				foreach($terms as $term){

					// var_dump($term);
					$term_slug = $term->slug;
					$term_name = $term->name;
					$term_id = $term->term_id;
					$term_count = $term->count;
					$term_link = get_term_link( $term_id, $taxonomy_name);


					if(get_term_meta( $term_id, 'brand_image', true )){
						$term_image = get_term_meta( $term_id, 'brand_image', true );
					} else {
						$term_image = '';
					}
					
					$html .= '<li class="manufacturers-list-item manufacturers-list-item-'.$term_slug.'">';
						//wrap everything in a link
						$html .= '<a href="'.$term_link.'">';	
							//do image section
							if(strlen($term_image) > 0){
								$html .= '<div class="image-container">';
									$html .= '<img src="'.$term_image.'" alt="'.$term_name.'" >';
								$html .= '</div>';	
							}

							//do title section
							$html .= '<div class="title-container">';
									$html .= '<h4>'.$term_name.' ('.$term_count.')</h4>';
							$html .= '</div>';	

						$html .= '</a>';

					$html .= '</li>';
					

				}


			$html .= '</ul>';

			echo $html;
		?>

	</div>

<?php //get_sidebar(); ?>
<?php get_footer(); ?>
